$crystal = 12000000
$baud = 1200
$regfile = "attiny2313.dat"
'onoff reset lock hdd polaczono wlaczwylacz

Config Pind.6 = Output                                      'hdd
Config Pinb.0 = Output                                      'power
Config Pinb.5 = Input                                       'on off
Config Pinb.7 = Input                                       'przycisk reset
Config Pinb.6 = Input                                       'przycisk lock

Config Timer1 = Timer , Prescale = 256

Hdd Alias Portd.6                                           ' stan dysku czyta lub nie
Powerk Alias Portb.0                                        ' dioda power od orzadzenia
Onoff Alias Pinb.5                                          ' stan kompa czy wl/wyl
Preset Alias Pinb.7                                         ' przycisk reset
Plock Alias Pinb.6                                          ' przycisk lock

Pron Alias 0                                                'przelacznik ustawiony na on
Proff Alias 1                                               'przelacznik ustawiony na off

Portb.0 = 0
Portd.6 = 0                                                 '1                                                'urz wlaczone
Portb.5 = 1                                                 'podcziaganie
Portb.6 = 1                                                 'podcziaganie
Portb.7 = 1                                                 'podcziaganie

Dim Wyslij As Byte
Dim Odbierz As Byte
Dim Odbierz2 As Byte
Dim Kom As Byte                                             ' Komunikacja
Dim Licznik As Byte
Dim Czas As Byte
Dim Czas2 As Byte                                           'dla migania diody power
Dim Wlacz As Byte                                           'czy komp wl
Dim Wylacz As Byte
Dim Blokuj As Byte


Enable Interrupts
Timer1 = 60849
Enable Timer1
On Timer1 Przerwanie

Poczatek:
Kom = 0
'Powerk = 0
'Waitms 200
'Powerk = 1
Licznik = 10
Czas2 = 0
Hdd = 0
Do
If Kom = 0 Then
Sprawdz:
   Odbierz = Inkey()
   If Odbierz = 0 Then Goto Sprawdz                         ' nic nie odebrano
   If Odbierz <> 77 Then                                    'spr komunikacji
      If Licznik = 0 Then Goto Poczatek                     'minela 1s wiec zamrugaj
      Goto Sprawdz
   Else
      Print Chr(65);                                        '1 bajt poprawnie oedebrany
      Licznik = 10
Sprawdz2:
      Odbierz = Inkey()
      If Odbierz = 0 Then
          If Licznik = 0 Then Goto Poczatek                 'minela 1s wiec zamrugaj
          Goto Sprawdz2
      Else
          If Odbierz <> 157 Then Goto Poczatek
          Print Chr(66);                                    '2 bajt kontrolny
          Incr Kom                                          'polaczono
          Powerk = 0                                        ' dopoki komw wyl dioda nie swieci
          Wlacz = 0 : Wylacz = 0 : Czas = 0
      End If
   End If
End If

Licznik = 10
Odbieranie:
If Licznik = 0 Then Goto Poczatek                           ' utrata komunikacji
Odbierz = Inkey()
If Odbierz = 0 Then Goto Odbieranie                         ' nic nie odebrano
If Odbierz > 4 Then Goto Poczatek                           'odebrano bledna liczba
Wyslij = 0
Odbierz2 = Odbierz
If Plock = 1 Then                                           ' gdy nie ma blokady
   If Odbierz = 1 Then                                      'komp jest wyl
  ' Blokuj = 0
      If Onoff = Proff And Wlacz = 0 And Wylacz = 0 Then
         Wlacz = 1 : Wylacz = 1                             '
      End If
      If Onoff = Pron And Wlacz = 1 And Wylacz = 1 Then     ' wl kompa
         Wlacz = 0 : Wyslij = 1 : Wylacz = 0
      End If
      If Wlacz <> Wylacz Then
         Wlacz = 0 : Wylacz = 0
      End If
   End If
   If Odbierz = 2 Or Odbierz = 4 Then                       ' komp jest wl
      If Blokuj = 0 Then
         If Wlacz = 0 And Wylacz = 0 Then Wlacz = 1
         If Wlacz = 1 And Wylacz = 1 Then Wylacz = 0
      End If
      If Onoff = Pron And Wlacz = 1 Then
         Wlacz = 0 : Wylacz = 1
      End If
      If Onoff = Proff And Wlacz = 0 Then
         If Wylacz = 1 Then
            Wyslij = 2 : Wylacz = 0                         ': Blokuj = 1            ' wyl kompa
         End If
      End If
   End If
   If Preset = 1 And Odbierz > 1 Then
      If Czas > 10 Then
         'If Wyslij = 0 Then
         Wyslij = 8                                         ' wyl na chama
         Czas = 0
      End If
      If Czas > 0 Then
         If Czas < 10 Then
             'If Wyslij = 0 Then
             Wyslij = 4                                     ' reset
             Czas = 0
         End If
      End If
   End If
End If

If Plock = 0 And Onoff = Proff Then                         ' po ustawieniu na of gdy jest lock
   Wlacz = 0 : Wylacz = 0                                   'nie da ise wykl kompa
End If

If Odbierz = 4 Then
   Powerk = 0 : Hdd = 1                                     'hdd
End If
If Odbierz = 2 Then
   Powerk = 1 : Hdd = 0                                     'power
End If
If Odbierz = 1 Then
   Powerk = 0 : Hdd = 0                                     'komp jest wyl
End If

If Wyslij = 0 Then Wyslij = 16                              'nie rob nic
Print Chr(wyslij);
Loop

Przerwanie:
'   Disable Timer1
Incr Czas2
If Czas2 = 10 Then                                          'gdy nie poloczono
   If Kom = 0 Then Toggle Powerk
   Czas2 = 0
End If
If Plock = 1 And Odbierz2 > 1 Then
   If Preset = 0 Then Incr Czas                             ' reset wcisniety
  ' Waitms 200
   If Czas > 15 Then Czas = 15
   Odbierz2 = 0
End If
If Plock = 0 Or Odbierz2 = 1 Then Czas = 0
Pominodbierz:
Decr Licznik
'Enable Timer1
 Timer1 = 60849
 'Timer1 = 65067                                              '63183'60849
Return